/***************************************************************************
*   Copyright (C) 2011-2017 by Denis Gottardello                          *
*   info@denisgottardello.it                                              *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 3 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

#include "commons.h"

int SecondsBetween(time_t First, time_t Second) {
    int Difference= First- Second;
    if (Difference>= 0) return Difference;
    else return Difference * -1;
}

#ifdef Q_OS_WIN
    #define CONV(x) ((wchar_t*)x.utf16())
    bool SetFileLastAccessModified(QString FileIn, time_t LastAccess, time_t LastModified) {
        struct _utimbuf NewTime;
        NewTime.actime= LastAccess;
        NewTime.modtime= LastModified;
        if (_wutime(CONV(FileIn), &NewTime)< 0) return false;
        else return true;
    }
#else
    bool SetFileLastAccessModified(QString FileIn, time_t LastAccess, time_t LastModified) {
        struct utimbuf NewTime;
        NewTime.actime= LastAccess;
        NewTime.modtime= LastModified;
        if (utime(FileIn.toStdString().c_str(), &NewTime)< 0) return false;
        else return true;
    }
#endif
