/***************************************************************************
*   Copyright (C) 2011-2017 by Denis Gottardello                          *
*   info@denisgottardello.it                                              *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 3 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

#ifndef COMMONS_H
#define COMMONS_H

#include "QString"
#include <utime.h>
#include "QFileInfo"
#include "QStringList"

const static int MODEANALYZE= 0;
const static int MODENULL= 1;
const static int MODESYNCHRONYZE= 2;
const static int SIDEA= 0;
const static int SIDEAEQUALTOSDIDEB= 0;
const static int SIDEATOSIDEB= 1;
const static int SIDEB= 1;
const static int SIDEBTOSDIDEA= 2;

struct FileItem {
    bool IsDirectory;
    qint64 Size;
    time_t LastAccess, LastModified;
    QString Path, File;
};

struct Profile {
    bool IgnoreFileDate, ShowDetails, DeleteFilesOnTargetSide, Snapshot;
    int Direction;
    QString Description, SideA, SideB;
    QStringList QSLExclusionFiles;
};

bool SetFileLastAccessModified(QString FileIn, time_t LastAccess, time_t LastModified);
//int SecondsBetween(QDateTime QDTFirst, QDateTime QDTSecond);
int SecondsBetween(time_t First, time_t Second);

#endif // COMMONS_H
