#include "qdemptydirectory.h"
#include "ui_qdemptydirectory.h"

QDEmptyDirectory::QDEmptyDirectory(QWidget *parent) : QDialog(parent), ui(new Ui::QDEmptyDirectory) {
    ui->setupUi(this);
}

QDEmptyDirectory::~QDEmptyDirectory() {
    delete ui;
}

void QDEmptyDirectory::GetComplete(long Files, long Directories) {
    delete ThEmptyDirectory;
    GetFile(tr("Deleted ")+ QString::number(Files)+ tr(" files and ")+ QString::number(Directories)+ " directories", "#0000ff");
    ui->QPBStop->setEnabled(false);
    ui->QPBStart->setEnabled(true);
}

void QDEmptyDirectory::GetFile(QString Path, QString Color) {
    while (ui->QLWLog->count()> 1024) ui->QLWLog->takeItem(0);
    QListWidgetItem* ListWidgetItem= new QListWidgetItem(Path, ui->QLWLog);
    ListWidgetItem->setData(Qt::ForegroundRole, QColor(Color));
    ui->QLWLog->addItem(ListWidgetItem);
}

void QDEmptyDirectory::on_QLEDirectory_textChanged(const QString &) {
    if (ui->QLEDirectory->text().length()> 0) ui->QPBStart->setEnabled(true);
}

void QDEmptyDirectory::on_QPBStart_clicked() {
    switch (QMessageBox(tr("Warning!"), tr("Are you sure?"), QMessageBox::Warning, QMessageBox::Yes | QMessageBox::Default, QMessageBox::No, QMessageBox::Escape).exec()) {
    case 3: {
            ui->QPBStart->setEnabled(false);
            StopImmediatly= false;
            ThEmptyDirectory= new QThEmptyDirectory(ui->QLEDirectory->text(), &StopImmediatly);
            connect(ThEmptyDirectory, SIGNAL(SendComplete(long,long)), this, SLOT(GetComplete(long,long)));
            connect(ThEmptyDirectory, SIGNAL(SendFile(QString,QString)), this, SLOT(GetFile(QString,QString)), Qt::BlockingQueuedConnection);
            ThEmptyDirectory->start();
            ui->QPBStop->setEnabled(true);
            break;
        }
    }
}

void QDEmptyDirectory::on_QPBStop_clicked() {
    ui->QPBStop->setEnabled(false);
    StopImmediatly= true;
}

void QDEmptyDirectory::on_QPBQuit_clicked() {
    if (ui->QPBStop->isEnabled()) on_QPBStop_clicked();
    this->accept();
}

void QDEmptyDirectory::on_QTBDirectory_clicked() {
    QString Path= QFileDialog::getExistingDirectory(this, tr("Directory to empty"), "", QFileDialog::ShowDirsOnly);
    if (Path!= NULL) ui->QLEDirectory->setText(Path);
}
