#include "qdhtmlpopup.h"
#include "ui_qdhtmlpopup.h"

QDHTMLPOpup::QDHTMLPOpup(QWidget *parent) : QDialog(parent, Qt::FramelessWindowHint), ui(new Ui::QDHTMLPOpup) {
    ui->setupUi(this);
    TimerMove= new QTimer(this);
    TimerHide= new QTimer(this);
    connect(TimerMove, SIGNAL(timeout()), this, SLOT(OnTimerMove()));
    connect(TimerHide, SIGNAL(timeout()), this, SLOT(OnTimerHide()));
}

QDHTMLPOpup::~QDHTMLPOpup() {
    delete TimerMove;
    delete TimerHide;
    delete ui;
}

void QDHTMLPOpup::OnTimerHide() {
    TimerHide->stop();
    this->setWindowOpacity(this->windowOpacity() / 2);
    if (this->windowOpacity()< 0.1) {
        this->hide();
        this->setWindowOpacity(0);
    }
    else TimerHide->start(128);
}

void QDHTMLPOpup::OnTimerMove() {
    this->setWindowOpacity(1);
    Point.setY(Point.y()- 32);
    this->move(Point);
    if (Point.y()+ this->height()<= QApplication::desktop()->geometry().height()) {
        TimerMove->stop();
        TimerHide->start(5000);
    }
}

void QDHTMLPOpup::ShowHTMLPopup(QString Text) {
    ui->QTEPopup->setHtml(Text);
    if (TimerHide->isActive()) {
        TimerHide->stop();
        this->setWindowOpacity(0);
        TimerMove->start(64);
    }
    Point= QPoint(QApplication::desktop()->geometry().width()- this->width(), QApplication::desktop()->geometry().height());
    this->move(Point);
    this->show();
}

void QDHTMLPOpup::ShowTextPopup(QString Text) {
    ui->QTEPopup->setText(Text);
    if (TimerHide->isActive()) {
        TimerHide->stop();
        this->setWindowOpacity(0);
        TimerMove->start(64);
    }
    Point= QPoint(QApplication::desktop()->geometry().width()- this->width(), QApplication::desktop()->geometry().height());
    this->move(Point);
    this->show();
}

void QDHTMLPOpup::showEvent(QShowEvent *event) {
    TimerMove->start(64);
}
