/***************************************************************************
*   Copyright (C) 2011-2017 by Denis Gottardello                          *
*   info@denisgottardello.it                                              *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 3 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

#ifndef THANALYZE_H
#define THANALYZE_H

#include <QThread>
#include "QDir"
#include "QDebug"
#include "commons.h"
#include "sys/stat.h"

class QThAnalyze : public QThread
{
    Q_OBJECT

public:
    QThAnalyze(QString InitialPath, int Side, QStringList QSLExclusionFiles);
    ~QThAnalyze();

signals:
    void SendAnalyzeComplete(int Side);
    void SendEmptyDirs(int Side, QString Path);
    void SendFiles(int Side, long Files, long Directories, QVector<FileItem> *QVSideList);

private:
    void run();
    bool DoStart;
    int Side;
    long Files, Directories;
    QString InitialPath;
    QVector<QFileInfo> QVExclusionFiles;
    void SideList(QString Path);

};

#endif // THANALYZE_H
