/***************************************************************************
*   Copyright (C) 2011-2017 by Denis Gottardello                          *
*   info@denisgottardello.it                                              *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 3 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

#include "qthsynchronize.h"

QThSynchronize::QThSynchronize(QFMainWindow *MainWindow, QString SideA, QString SideB) : QThread() {
    this->MainWindow= MainWindow;
    this->SideA= SideA;
    this->SideB= SideB;
    DoStart= true;
}

QThSynchronize::~QThSynchronize() {
    DoStart= false;
    while (this->isRunning()) msleep(10);
}

void QThSynchronize::run() {
    Objects= 0;
    for (int count= 0; count< MainWindow->QVBeDeletedToSideA.size(); count++) {
        if (!DoStart) break;
        if (QFile::remove(SideA+ MainWindow->QVBeDeletedToSideA[count].Path+ MainWindow->QVBeDeletedToSideA[count].File)) Log(SideA+ MainWindow->QVBeDeletedToSideA[count].Path+ MainWindow->QVBeDeletedToSideA[count].File+ tr(" deleted"), "#0000ff");
        if (!MainWindow->QVBeDeletedToSideA[count].IsDirectory) {
            if (QFile::remove(SideA+ MainWindow->QVBeDeletedToSideA[count].Path+ MainWindow->QVBeDeletedToSideA[count].File)) Log(SideA+ MainWindow->QVBeDeletedToSideA[count].Path+ MainWindow->QVBeDeletedToSideA[count].File+ tr(" deleted"), "#0000ff");
            else Log(SideA+ MainWindow->QVBeDeletedToSideA[count].Path+ MainWindow->QVBeDeletedToSideA[count].File+ tr(" error on remove!"), "#ff0000");
            Objects++;
        }
    }
    for (int count= 0; count< MainWindow->QVBeDeletedToSideA.size(); count++) {
        if (!DoStart) break;
        if (MainWindow->QVBeDeletedToSideA[count].IsDirectory) {
            QDir Dir;
            if (Dir.rmdir(SideA+ MainWindow->QVBeDeletedToSideA[count].Path+ MainWindow->QVBeDeletedToSideA[count].File)) Log(SideA+ MainWindow->QVBeDeletedToSideA[count].Path+ MainWindow->QVBeDeletedToSideA[count].File+ tr(" deleted"), "#0000ff");
            else Log(SideA+ MainWindow->QVBeDeletedToSideA[count].Path+ MainWindow->QVBeDeletedToSideA[count].File+ tr(" error on remove!"), "#ff0000");
            Objects++;
        }
    }
    for (int count= 0; count< MainWindow->QVBeDeletedToSideB.size(); count++) {
        if (!DoStart) break;
        if (!MainWindow->QVBeDeletedToSideB[count].IsDirectory) {
            if (QFile::remove(SideB+ MainWindow->QVBeDeletedToSideB[count].Path+ MainWindow->QVBeDeletedToSideB[count].File)) Log(SideB+ MainWindow->QVBeDeletedToSideB[count].Path+ MainWindow->QVBeDeletedToSideB[count].File+ tr(" deleted"), "#0000ff");
            else Log(SideB+ MainWindow->QVBeDeletedToSideB[count].Path+ MainWindow->QVBeDeletedToSideB[count].File+ tr(" error on remove!"), "#ff0000");
            Objects++;
        }
    }
    for (int count= 0; count< MainWindow->QVBeDeletedToSideB.size(); count++) {
        if (!DoStart) break;
        if (MainWindow->QVBeDeletedToSideB[count].IsDirectory) {
            QDir Dir;
            if (Dir.rmdir(SideB+ MainWindow->QVBeDeletedToSideB[count].Path+ MainWindow->QVBeDeletedToSideB[count].File)) Log(SideB+ MainWindow->QVBeDeletedToSideB[count].Path+ MainWindow->QVBeDeletedToSideB[count].File+ tr(" deleted"), "#0000ff");
            else Log(SideB+ MainWindow->QVBeDeletedToSideB[count].Path+ MainWindow->QVBeDeletedToSideB[count].File+ tr(" error on remove!"), "#ff0000");
            Objects++;
        }
    }
    for (int count= 0; count< MainWindow->QVBeCopiedToSideA.size(); count++) {
        if (!DoStart) break;
        if (MainWindow->QVBeCopiedToSideA[count].IsDirectory) {
            QDir Dir;
            if (Dir.mkpath(SideA+ MainWindow->QVBeCopiedToSideA[count].Path+ MainWindow->QVBeCopiedToSideA[count].File)) Log(SideA+ MainWindow->QVBeCopiedToSideA[count].Path+ MainWindow->QVBeCopiedToSideA[count].File+ " created.", "#0000ff");
            else Log(SideA+ MainWindow->QVBeCopiedToSideA[count].Path+ MainWindow->QVBeCopiedToSideA[count].File+ tr(" error on created!"), "#ff0000");
            Objects++;
        }
    }
    for (int count= 0; count< MainWindow->QVBeCopiedToSideA.size(); count++) {
        if (!DoStart) break;
        if (!MainWindow->QVBeCopiedToSideA[count].IsDirectory) {
            QFile QFSource(SideB+ MainWindow->QVBeCopiedToSideA[count].Path+ MainWindow->QVBeCopiedToSideA[count].File);
            QFile QFDestination(SideA+ MainWindow->QVBeCopiedToSideA[count].Path+ MainWindow->QVBeCopiedToSideA[count].File);
            QFileInfo QFIPath(QFDestination);
            if (!QFIPath.absoluteDir().exists()) {
                QDir Dir;
                Dir.mkpath(SideA+ MainWindow->QVBeCopiedToSideA[count].Path);
            }
            if (QFDestination.exists()) if (!QFDestination.remove()) Log(QFDestination.fileName()+ tr(" error on remove!"), "#ff0000");
            if(QFSource.open(QIODevice::ReadOnly) && QFDestination.open(QIODevice::WriteOnly)) {
                QDateTime QDTStart= QDateTime::currentDateTime();
                quint64 ByteOut= 0;
                while(!QFSource.atEnd()) {
                    QByteArray QBAByteIn= QFSource.read(4096);
                    QFDestination.write(QBAByteIn);
                    QFDestination.flush();
                    ByteOut+= QBAByteIn.length();
                    if (!DoStart) break;
                }
                QFSource.close();
                QFDestination.close();
                if (!SetFileLastAccessModified(QFDestination.fileName(), MainWindow->QVBeCopiedToSideA[count].LastAccess, MainWindow->QVBeCopiedToSideA[count].LastModified)) Log(QFDestination.fileName()+ tr(" error on change file date time!"), "#ff0000");
                Log(QFSource.fileName()+ tr(" copied")+ Copied(ByteOut, QDTStart), "#0000ff");
            } else Log(QFSource.fileName()+ tr(" error on copy to ")+ QFDestination.fileName()+ "", "#ff0000");
            Objects++;
        }
    }
    for (int count= 0; count< MainWindow->QVBeCopiedToSideB.size(); count++) {
        if (!DoStart) break;
        if (MainWindow->QVBeCopiedToSideB[count].IsDirectory) {
            QDir Dir;
            if (Dir.mkpath(SideB+ MainWindow->QVBeCopiedToSideB[count].Path+ MainWindow->QVBeCopiedToSideB[count].File)) Log(SideB+ MainWindow->QVBeCopiedToSideB[count].Path+ MainWindow->QVBeCopiedToSideB[count].File+ " created.", "#0000ff");
            else Log(SideB+ MainWindow->QVBeCopiedToSideB[count].Path+ MainWindow->QVBeCopiedToSideB[count].File+ tr(" error on created!"), "#ff0000");
            Objects++;
        }
    }
    for (int count= 0; count< MainWindow->QVBeCopiedToSideB.size(); count++) {
        if (!DoStart) break;
        if (!MainWindow->QVBeCopiedToSideB[count].IsDirectory) {
            QFile QFSource(SideA+ MainWindow->QVBeCopiedToSideB[count].Path+ MainWindow->QVBeCopiedToSideB[count].File);
            QFile QFDestination(SideB+ MainWindow->QVBeCopiedToSideB[count].Path+ MainWindow->QVBeCopiedToSideB[count].File);
            if (QFDestination.exists()) if (!QFDestination.remove()) Log(QFDestination.fileName()+ tr(" error on remove!"), "#ff0000");;
            if(QFSource.open(QIODevice::ReadOnly) && QFDestination.open(QIODevice::WriteOnly)) {
                QDateTime QDTStart= QDateTime::currentDateTime();
                quint64 ByteOut= 0;
                while(!QFSource.atEnd()) {
                    QByteArray QBAByteIn= QFSource.read(4096);
                    QFDestination.write(QBAByteIn);
                    QFDestination.flush();
                    ByteOut+= QBAByteIn.length();
                    if (!DoStart) break;
                }
                QFSource.close();
                QFDestination.close();
                if (!SetFileLastAccessModified(QFDestination.fileName(), MainWindow->QVBeCopiedToSideB[count].LastAccess, MainWindow->QVBeCopiedToSideB[count].LastModified)) Log(QFDestination.fileName()+ tr(" error on change file date time!"), "#ff0000");
                Log(QFSource.fileName()+ tr(" copied")+ Copied(ByteOut, QDTStart), "#0000ff");
            } else Log(QFSource.fileName()+ tr(" error on copy to ")+ QFDestination.fileName(), "#ff0000");
            Objects++;
        }
    }
    if (DoStart) emit GetSynchronizeComplete();
}

QString QThSynchronize::Copied(quint64 ByteOut, QDateTime QDTStart) {
    if (QDTStart.secsTo(QDateTime::currentDateTime())> 0) {
        if (ByteOut / 1024 / QDTStart.secsTo(QDateTime::currentDateTime())< 1024) return " in "+ QString::number(ByteOut / 1024 / QDTStart.secsTo(QDateTime::currentDateTime()), 'f', 1)+ " Kbyte/s.";
        else return " in "+ QString::number(ByteOut / 1024 / 1024 /QDTStart.secsTo(QDateTime::currentDateTime()), 'f', 1)+ " Mbyte/s.";
    } else return ".";
}

void QThSynchronize::Log(QString Row, QString Color) {
    if (DoStart) emit SendLog(Row, Color, Objects);
}
