/***************************************************************************
*   Copyright (C) 2011-2017 by Denis Gottardello                          *
*   info@denisgottardello.it                                              *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 3 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

#ifndef THSYNCHRONIZE_H
#define THSYNCHRONIZE_H

#include <QThread>
#include "QDir"
#include "QDebug"
#include "commons.h"
#ifndef QFMAINWINDOW_H
    class QThSynchronize;
    #include "qfmainwindow.h"
#endif
#include "QDateEdit"

class QThSynchronize : public QThread
{
    Q_OBJECT

public:
    QThSynchronize(QFMainWindow *MainWindow, QString SideA, QString SideB);
    ~QThSynchronize();

signals:
    void GetSynchronizeComplete();
    void SendLog(QString Row, QString Color, long Objects);

private:
    void run();
    bool DoStart;
    long Objects;
    QFMainWindow *MainWindow;
    QString SideA, SideB;
    QString Copied(quint64 ByteOut, QDateTime QDTStart);
    void Log(QString Row, QString Color);

};

#endif // THSYNCHRONIZE_H
